; ---purpose---
; Recursively count the atoms of a list.
; Members of all sublists are included.
; For example,
; -
; (COUNT '(1(2(4)))) => '#3.

; ---args---
; X - list

; ---keywords---
; COUNT function, list, member, size

; ---see-also---
; LENGTH, APPEND, COPY

; ---example---
; (COUNT '(A B (C (D) E) ((F))))

:C LIB/INCR.L

; ---model---
; (DEFUN COUNT (X)
;	(COND ((NULL X) '#0)
;		((ATOM X) '#1)
;		(T (PLUS (COUNT (CAR X)) (COUNT (CDR X))))))

; ---code---
; TAIL-RECURSIVE VERSION
(DEFUN COUNT (X)
	(LABEL ((CNT (LAMBDA (X R S)
		(COND ((NULL X)
				(COND ((NULL S) R)
					(T (CNT (CAR S) R (CDR S)))))
			((ATOM X)
				(CNT NIL (INCR R) S))
			(T
				(CNT (CAR X) R (CONS (CDR X) S)))))))
		(CNT X '#0 NIL)))
