; ---purpose---
; Compute the X raised to the power of Y.
; Both X and Y are natural numbers represented by
; lists of digits.

; ---args---
; X - list (base)
; Y - list (exponent)

; ---keywords---
; EXPT function, base, exponent, power

; ---see-also---
; DIGITS, IEXPT, FAC, GCD, PRODUCT, SUM

; ---example---
; (EXPT '#3 '#9)

(DEFINE EXPT T)

:C LIB/DIGITS.L
:C LIB/ZEROP.L
:C LIB/TIMES.L
:C LIB/DECR.L

; ---model---
; (DEFUN EXPT (X Y)
;	(COND ((ZEROP Y) '#1)
;		(T (TIMES X (EXPT X (DECR Y))))))

; ---code---
(DEFUN EXPT (X Y)
	(LABEL ((EXP (LAMBDA (Y R)
			(COND ((ZEROP Y) R)
				(T (EXP (DECR Y) (TIMES X R)))))))
		(EXP Y '#1)))
