; ---purpose---
; Check if an expression X is the head of an
; expression Y.

; ---args---
; X - possible head
; Y - expression

; ---keywords---
; HEADP function, list, pair, head

; ---see-also---
; TAILP, CAAR, CAAAR, CAAAAR, LISTP

; ---example---
; (HEADP '(A B C) '(A B C D E F))

:C LIB/EQUAL.L

; ---code---
(DEFUN HEADP (X Y)
	(COND ((NULL Y) (NULL X))
		((NULL X) *T*)
		((EQUAL (CAR X) (CAR Y)) (HEADP (CDR X) (CDR Y)))
		(T *F*)))
