; ---purpose---
; Subtract two decimal integer numbers. Numbers are
; represented by lists of digits.

; ---args---
; A - list of digits
; B - list of digits (number to be subtracted)

; ---keywords---
; IDIFFERENCE function, difference, subtract, subtraction
; arithmetics, integer

; ---see-also---
; DIGITS, DIFFERENCE, IPLUS, IDIVIDE, IQUOTIENT, IREMAINDER
; ITIMES, MINUS

; ---example---
; (IDIFFERENCE '#5 '#7)

(DEFINE IDIFFERENCE T)

:C LIB/DIGITS.L
:C LIB/ABS.L
:C LIB/LESSP.L
:C LIB/IPLUS.L
:C LIB/DIFFERENCE.L
:C LIB/INTEGER.L

; ---code---
(DEFUN IDIFFERENCE (A B)
	(LABEL

	((IDIFF (LAMBDA (A B)
		(COND ((EQ (CAR B) '-)
				(IPLUS A (ABS B)))		; B<0
			((EQ (CAR A) '-)
				(IPLUS A (MINUS B)))	; B>=0, A<0
			((LESSP (CDR A) (CDR B))
				(CONS '- (DIFFERENCE (CDR B) (CDR A))))		; A>=0, B>=0, A<B
			(T (CONS '+ (DIFFERENCE (CDR A) (CDR B))))))))	; A>=0, B>=0, A>=B

	(IDIFF (INTEGER A) (INTEGER B))))
