; ---purpose---
; Compute the X raised to the power of Y.
; Both X and Y are integer numbers represented by
; lists of digits. Y must be positive or zero.

; ---args---
; X - list (base)
; Y - list (exponent)

; ---keywords---
; IEXPT function, base, exponent, power

; ---see-also---
; DIGITS, EXPT, GCD, FAC

; ---example---
; (IEXPT '#-3 '#9)

(DEFINE IEXPT T)

:C LIB/DIGITS.L
:C LIB/ZEROP.L
:C LIB/ITIMES.L
:C LIB/DECR.L
:C LIB/INTEGER.L
:C LIB/NATURAL.L

; ---model---
; (DEFUN IEXPT (X Y)
; 	(LABEL ((EXP (LAMBDA (X Y R)
; 			(COND ((ZEROP Y) R)
; 				(T (EXP X (DECR Y) (ITIMES X R)))))))
; 		(EXP (INTEGER X) (NATURAL Y) '#+1)))

; ---code---
(DEFUN IEXPT (X Y)
	(LABEL ((XI (INTEGER X))
		(EXP (LAMBDA (Y R)
			(COND ((ZEROP Y) R)
				(T (EXP (DECR Y) (ITIMES XI R)))))))
		(EXP (NATURAL Y) '#+1)))
