; ---purpose---
; Compute the intersection of two sets.
; Sets are represented by lists of unique
; members.

; ---args---
; A - set
; B - set

; ---keywords---
; INTERSECTION function, intersection
; sets, set theory

; ---see-also---
; UNION, MEMBER, REMOVE, UNIQUE

; ---example---
; (INTERSECTION '(AB CD EF) '(EF BC AB))

:C LIB/MEMBER.L
:C LIB/REVERSE.L

; ---model---
; (DEFUN INTERSECTION (A B)
;	(COND ((NULL A) NIL)
;		((MEMBER (CAR A) B)
;			(CONS (CAR A) (INTERSECTION (CDR A) B)))
;		(T (INTERSECTION (CDR A) B))))

; ---code---
(DEFUN INTERSECTION (A B)
	(LABEL ((ISEC (LAMBDA (A R)
			(COND ((NULL A) (REVERSE R))
				((MEMBER (CAR A) B)
					(ISEC (CDR A) (CONS (CAR A) R)))
				(T (ISEC (CDR A) R))))))
		(ISEC A NIL)))
