; ---purpose---
; Sort a list using insertion sort. A predicate is
; used to define ; the desired order of members.
; It should return *T* for each two members in the
; desired order.

; ---args---
; A - list to sort
; P - predicate

; ---keywords---
; ISORT function, sorting, ordering, insertion sort

; ---see-also---
; INSERT, SORT, ORDEREDP

; ---example---
; :L LIB/LESSP.L
; (ISORT '(#5 #9 #1 #7 #3 #0 #2 #4 #8 #6) LESSP)

:C LIB/INSERT.L

; ---model---
; (DEFUN ISORT (A P)
;	(COND ((NULL A) NIL)
;		(T (INSERT (CAR A) (ISORT (CDR A) P) P))))

; ---code---
(DEFUN ISORT (A P)
	(LABEL ((SRT (LAMBDA (A R)
		(COND ((NULL A) R)
			(T (SRT (CDR A) (INSERT (CAR A) R P)))))))
	(SRT A NIL)))
