; ---purpose---
; Compute the product of two decimal integer numbers.
; Numbers are represented by lists of decimal digits.

; ---args---
; A - list of digits (factor 1)
; B - list of digits (factor 2)

; ---keywords---
; ITIMES function, times, multiply, multiplication, product
; arithmetics, integer

; ---see-also---
; DIGITS, TIMES, IPLUS, IDIFFERENCE, IDIVIDE, IQUOTIENT
; IREMAINDER, MINUS

; ---example---
; (ITIMES '#12 '#3)

(DEFINE ITIMES T)

:C LIB/DIGITS.L
:C LIB/MINUS.L
:C LIB/INTEGER.L
:C LIB/TIMES.L

; ---code---
(DEFUN ITIMES (A B)
	(LABEL ((_ITIMES (LAMBDA (A B)
		; avoid leading zeroes in result
		(COND ((ZEROP A) '#+0)
			; handle signs
			((EQ (CAR A) (CAR B))
				(CONS '+ (TIMES (CDR A) (CDR B))))
			(T (MINUS (TIMES (CDR A) (CDR B))))))))
	(_ITIMES (INTEGER A) (INTEGER B))))
