; ---purpose---
; Compute the length of a list. The result is a
; natural number represented by a list of digits.

; ---args---
; X - list

; ---keywords---
; LENGTH function, lists, length

; ---see-also---
; DIGITS, APPEND, REVERSE, COUNT

; ---example---
; (LENGTH '(A B C D E F))

:C LIB/INCR.L

; ---model---
; (DEFUN LENGTH (X)
;	(COND ((NULL X) '#0)
;		(T (INCR (LENGTH (CDR X))))))

; ---code---
(DEFUN LENGTH (X)
	(LABEL ((LEN (LAMBDA (X R)
			(COND ((NULL X) R)
				(T (LEN (CDR X) (INCR R)))))))
		(LEN X '#0)))
