; ---purpose---
; Map two lists into one using a given function.
; The lists must be of the same length and the
; function must take two arguments.

; ---args---
; X - list
; Y - list
; F - function

; ---keywords---
; MAP function, mapping, lists

; ---see-also---
; MAPCAR, MAPLIS, REDUCE

; ---example---
; (MAP '(A B C) '(D E F) CONS)

:C LIB/REVERSE.L

; ---model---
; (DEFUN MAP (X Y F)
;	(COND ((NULL X) NIL)
;		((NULL Y) NIL)
;		(T (CONS (F (CAR X) (CAR Y))
;			(MAP (CDR X) (CDR Y) F)))))

; ---code---
(DEFUN MAP (X Y F)
	(LABEL ((_MAP (LAMBDA (X Y R)
			(COND ((NULL X) R)
				((NULL Y) R)
				(T (_MAP (CDR X) (CDR Y)
					(CONS (F (CAR X) (CAR Y)) R)))))))
		(REVERSE (_MAP X Y NIL))))
