; ---purpose---
; Apply a function to each CDR of a list.

; ---args---
; A - list
; F - function to apply to each sublist

; ---keywords---
; MAPLIS function, mapping, lists, CDR

; ---see-also---
; MAP, MAPCAR, REDUCE

; ---example---
; :L LIB/REVERSE.L
; (MAPLIS '(#1 #2 #3) REVERSE)

:C LIB/REVERSE.L

; ---model---
; (DEFUN MAPLIS (A F)
;	(COND ((NULL T) B)
;		(T (CONS (F (CDR A)) (MAPLIS (CDR A) F)))))

; ---code---
(DEFUN MAPLIS (A F)
	(LABEL ((MAPL (LAMBDA (A B)
		(COND ((NULL A) (REVERSE B))
			(T (MAPL (CDR A) (CONS (F A) B)))))))
	(MAPL A NIL)))
