; ---purpose---
; Find the maximum of a set/list. Natural version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; MAX function, maximum, comparison, arithmetics, natural

; ---see-also---
; DIGITS, IMAX, GREATERP, MIN

; ---example---
; (MAX '(#22 #33 #11))

:C LIB/CAAR.L
;C LIB/CADR.L
;C LIB/CDDR.L
:C LIB/GREATERP.L

; ---code---
(DEFUN MAX (A)
	(COND ((NULL (CDR A)) (CAR A))
		((GREATERP (CAR A) (CADR A))
			(MAX (CONS (CAR A) (CDDR A))))
		(T (MAX (CDR A)))))
