; ---purpose---
; Check if any member of a list is equal to a given
; S-expression.

; ---args---
; X - expression to find
; A - list

; ---keywords---
; MEMBER function, member of, sets, set theory

; ---see-also---
; UNION, INTERSECTION, UNIQUE

; ---example---
; (MEMBER '(C D) '(A B (C D) E F))

:C LIB/EQUAL.L

; ---model---
; (DEFUN MEMBER (X A)
;	(COND ((NULL A) *F*)
;		((EQUAL (CAR A) X) T)
;		(T (MEMBER X (CDR A)))))

; ---code---
(DEFUN MEMBER (X A)
	(LABEL ((MEM (LAMBDA (A)
			(COND ((NULL A) *F*)
				((EQUAL (CAR A) X) T)
				(T (MEM (CDR A)))))))
		(MEM A)))
