; ---purpose---
; Find the minimum of a set/list. Natural version.
; The list may not be empty.

; ---args---
; A - list

; ---keywords---
; MIN function, minimum, comparison, arithmetics, natural

; ---see-also---
; DIGITS, IMIN, LESSP, MAX

; ---example---
; (MIN '(#22 #33 #11))

:C LIB/CAAR.L
;C LIB/CADR.L
;C LIB/CDDR.L
:C LIB/LESSP.L

; ---code---
(DEFUN MIN (A)
	(COND ((NULL (CDR A)) (CAR A))
		((LESSP (CAR A) (CADR A))
			(MIN (CONS (CAR A) (CDDR A))))
		(T (MIN (CDR A)))))
