; ---purpose---
; Compute the negative value of an integer.
; If a positive natural number is passed to MINUS,
; it is silently converted to an integer.

; ---args---
; X - list of digits

; ---keywords---
; MINUS function, negative value, sign, arithmetics, integer

; ---see-also---
; DIGITS, MINUSP, DIFFERENCE, IDIFFERENCE, ABS

; ---example---
; (MINUS '#567)

:C LIB/DIGITS.L
:C LIB/ZEROP.L

; ---code---
(DEFUN MINUS (X)
	(COND ((ZEROP X) X)
		((EQ (CAR X) '+) (CONS '- (CDR X)))
		((EQ (CAR X) '-) (CONS '+ (CDR X)))
		(T (CONS '- X))))

