; ---purpose---
; Normalize a decimal number by
; removing leading zeroes.

; ---args---
; X - list of digits

; ---keywords---
; NORMALIZE function, normalize, normal form, canonical number
; numbers, digits, decimal, integer, natural

; ---see-also---
; DIGITS, DIFFERENCE, DIVIDE

; ---example---
; (NORMALIZE '#+000567)

(DEFINE NORMALIZE T)

:C LIB/DIGITS.L
:C LIB/CAAR.L
;C LIB/CDAR.L
:C LIB/CAAAR.L
:C LIB/CAADR.L
:C LIB/CDADR.L

; ---code---
(DEFUN NORMALIZE (X)
	(LABEL ((NORM (LAMBDA (X)
		(COND ((NULL (CDR X)) X)
			((EQ (CAR X) 0)
				(NORM (CDR X)))
			(T X)))))
		(COND ((EQ (CAR X) '+)
				(CONS '+ (NORM (CDR X))))
			((EQ (CAR X) '-)
				(CONS '- (NORM (CDR X))))
			(T (NORM X)))))
