; ---purpose---
; Test if an S-expression represents a
; number. Numbers are lists of decimal digits
; with an optional sign.

; ---args---
; A - expression

; ---keywords---
; NUMBERP function, numeric, numbers, digits, predicate

; ---see-also---
; DIGITS, ZEROP, MINUSP, NATURALP

; ---example---
; (NUMBERP '#-123)

:C LIB/DIGITS.L
:C LIB/MEMBER.L

; ---code---
(DEFUN NUMBERP (A)
	(LABEL ((NUMP (LAMBDA (A)
		(COND ((ATOM A) *F*)
				((MEMBER (CAR A) DIGITS)
					(COND ((NULL (CDR A)) T)
						(T (NUMP (CDR A)))))
			(T *F*)))))
	(COND ((ATOM A) *F*)
		((EQ (CAR A) '+) (NUMP (CDR A)))
		((EQ (CAR A) '-) (NUMP (CDR A)))
		(T (NUMP A)))))
