; ---purpose---
; Remove a members from a list.

; ---args---
; A - list
; P - predicate to match members to remove

; ---keywords---
; REMOVE function, lists, sets, set theory, member, remove

; ---see-also---
; INSERT, MEMBER

; ---example---
; :L LIB/NUMBERP.L
; (REMOVE '(ABC #123 DEF #456 GHI) NUMBERP)

:C LIB/REVERSE.L

; ---model---
; (DEFUN REMOVE (A P)
;	(COND ((NULL A) NIL)
;		((P (CAR A)) (CDR A))
;		(T (CONS (CAR A) (REMOVE (CDR A) P)))))

; ---code---
(DEFUN REMOVE (A P)
	(LABEL ((REM (LAMBDA (A R)
		(COND ((NULL A) (REVERSE R))
			((P (CAR A)) (REM (CDR A) R))
			(T (REM (CDR A) (CONS (CAR A) R)))))))
	(REM A NIL)))
