; ---purpose---
; Retrieve a binding from an association list, providing a
; default value. For a definition of association lists, see
; ASSOC.

; ---args---
; X - key to find
; Y - association list to search
; C - constant function to apply if X does not exist

; ---keywords---
; SASSOC function, association lists, associate, default

; ---see-also---
; ASSOC, PAIR, SUBLIS

; ---example---
; (SASSOC IV '((I.1) (II.2) (III.3)) (LAMBDA () NIL))

:C LIB/CAAR.L
;C LIB/CDAR.L

; ---model---
; (DEFUN SASSOC (X Y C)
;	(COND ((NULL Y) (C))
;		((EQ (CAAR Y) X) (CAR Y))
;		(T (SASSOC X (CDR Y) C))))

; ---code---
(DEFUN SASSOC (X Y C)
	(LABEL ((SAS (LAMBDA (Y)
			(COND ((NULL Y) (C))
				((EQ (CAAR Y) X) (CAR Y))
				(T (SAS (CDR Y)))))))
		(SAS Y)))
