; ---purpose---
; Extract the tail of a list where the first
; member of the tail has a given property.
; Evaluate to NIL if no such member exists.

; ---args---
; A - list
; P - predicate defining property to find

; ---keywords---
; SOME function, property, predicate

; ---see-also---
; ANY, SOME, MEMBER, REMOVE, UNIQUE

; ---example---
; (SOME '((A B C) X (D E F)) ATOM)

; ---model---
; (DEFUN SOME (X P)
; 	(COND ((NULL X) NIL)
; 		((P (CAR X)) X)
; 		(T (SOME (CDR X) P))))

; ---code---
(DEFUN SOME (X P)
	(LABEL ((SOM (LAMBDA (X)
			(COND ((NULL X) NIL)
				((P (CAR X)) X)
				(T (SOM (CDR X)))))))
		(SOM X)))
