; ---purpose---
; Compute the square root of a natural number.
; Numbers are represented by lists of digits.
; This function returns a natural result, which
; may be inexact.

; ---args---
; X - square of root to extract

; ---keywords---
; SQUAREROOT function, root, square, square root
; arithmetics, natural

; ---see-also---
; DIGITS, TIMES, QUOTIENT

; ---example---
; (SQUAREROOT '#144)

:C LIB/EQUAL.L
:C LIB/TIMES.L
:C LIB/QUOTIENT.L
:C LIB/PLUS.L
:C LIB/GREATERP.L
:C LIB/NGREATERP.L
:C LIB/DECR.L
:C LIB/INCR.L

; ---model---
; (DEFUN SQUAREROOT (SQUARE)
;	(LABEL ((BASE SQUARE)
;		(SQR (LAMBDA (X LAST)
;			(COND ((LOGAND (NGREATERP (TIMES X X) BASE)
;						(GREATERP (TIMES (INCR X) (INCR X)) BASE))
;					X)
;				(T (SQR (QUOTIENT
;						(PLUS X (QUOTIENT BASE X))
;						'#2) X))))))
;		(SQR BASE '#0)))

; ---code---
(DEFUN SQUAREROOT (SQUARE)
	(LABEL ((BASE SQUARE)
		(SQR (LAMBDA (X LAST)
			(COND ((EQUAL LAST X) X)
				((EQUAL LAST (INCR X))
					(COND ((GREATERP (TIMES X X) BASE) (DECR X))
						(T X)))
				(T (SQR (QUOTIENT
						(PLUS X (QUOTIENT BASE X))
						'#2) X))))))
		(SQR BASE '#0)))
