; ---purpose---
; Compute the sum of a sequence of positive numbers.
; Number are represented by lists of digits.

; ---args---
; N - least value of sequence
; M - maximum value of seqence

; ---keywords---
; SUM function, product of sequence

; ---see-also---
; DIGITS, EXPT, FAC, GCD, PRODUCT

; ---example---
; (SUM '#2 '#5)

(DEFINE SUM T)

:C LIB/DIGITS.L
:C LIB/EQUAL.L
:C LIB/GREATERP.L
:C LIB/NATURAL.L
:C LIB/INCR.L
:C LIB/DECR.L
:C LIB/PLUS.L
:C LIB/TIMES.L
:C LIB/QUOTIENT.L
:C LIB/DIFFERENCE.L

; ---model---
; (DEFUN SUM(N M)
;	(COND ((EQUAL N M) M)
;			(T (PLUS N (SUM (INCR N) M)))))

; ---code---
(DEFUN SUM(N M)
	(LABEL ((NN (NATURAL N)) (NM (NATURAL M))
		(_SUM (LAMBDA (N M)
			(LABEL ((X (PLUS (DIFFERENCE M N) '#1)))
				(PLUS (QUOTIENT (PLUS (TIMES X X) X) '#2)
					(TIMES (DECR N) X))))))
		(COND ((GREATERP NN NM) (BOTTOM 'SUM:RANGE))
			(T (_SUM NN NM)))))
