; ---purpose---
; Sort a list using tree sort. A predicate is used
; to define the desired order of members. It should
; return *T* for each two members in the desired
; order.

; ---args---
; X - list
; P - predicate

; ---keywords---
; TREE-SORT function, trees, lists, sorting, ordering,
; tree sort

; ---see-also---
; TREE-INSERT, TREE-FLATTEN, TREE-ASSOC, SORT

; ---example---
; :L LIB/LESSP.L
; (TREE-SORT '(#5 #9 #1 #7 #3 #0 #2 #4 #8 #6) LESSP)

:C LIB/TREE-INSERT.L
:C LIB/TREE-FLATTEN.L

; ---code---
(DEFUN TREE-SORT (X P)
	(LABEL ((SORT-TREE (LAMBDA (X TREE)
			(COND ((NULL X) (TREE-FLATTEN TREE))
				(T (SORT-TREE (CDR X)
					(TREE-INSERT (CAR X) TREE P)))))))
		(SORT-TREE X NIL)))

