; ---purpose---
; Transform a list into a set (a list containing
; only unique elements).

; ---args---
; A - list

; ---keywords---
; UNIQUE function, unique, sets, set theory

; ---see-also---
; INTERSECTION, UNION, MEMBER, REMOVE

; ---example---
; (UNIQUE '(AB CD EF CD GH EF))

:C LIB/MEMBER.L
:C LIB/REVERSE.L

; ---model---
; (DEFUN UNIQUE (A)
;	(COND ((NULL A) A)
;		((MEMBER (CAR A) (CDR A)) (UNIQUE (CDR A)))
;		(T (CONS (CAR A) (UNIQUE (CDR A))))))

; ---code---
(DEFUN UNIQUE (A)
	(LABEL ((UNI (LAMBDA (A R)
		(COND ((NULL A) (REVERSE R))
			((MEMBER (CAR A) R) (UNI (CDR A) R))
			(T (UNI (CDR A) (CONS (CAR A) R)))))))
	(UNI A NIL)))
